package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.capabilities.ChestKeyProvider;
import me.km.capabilities.IChestKey;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;

public class CommandTest extends ModuleCommand
{
    public CommandTest(Module m) 
    {
        super("test", m);
        super.setDescription("Für Tests");
        super.setUsage("/test");
        super.setPermission(Permissions.TEST);
    }   

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayerMP))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        EntityPlayerMP p = (EntityPlayerMP) cs;
        ItemStack stack = p.getHeldItemMainhand();
        if(arg.length >= 1 && stack.hasCapability(ChestKeyProvider.CHEST_KEY_CAP, null))
        {
            IChestKey key = stack.getCapability(ChestKeyProvider.CHEST_KEY_CAP, null);
            if(key == null)
            {
                // will never happen
                return true;
            }
            switch(arg[0])
            {
                case "key":
                {
                    if(arg.length >= 2)
                    {
                        key.setKey(arg[1]);
                        this.getModule().send(cs, "Schlüssel geändert auf '" + arg[1] + "'");
                    }
                    else
                    {
                        this.getModule().send(cs, "'" + key.getKey() + "'");
                    }
                    break;
                }
                case "copy":
                {
                    key.setCopy(!key.isCopy());
                    this.getModule().send(cs, "Copy-Status ist nun '" + key.isCopy() + "'");
                    break;
                }
            }
        }
        return true;
    }
}
